var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { QuestionnairesContractError, EVMContractAddress, } from "@snickerdoodlelabs/objects";
import { injectable } from "inversify";
import { ResultAsync } from "neverthrow";
import { ERC7529Contract } from "../implementations/ERC7529Contract.js";
import { ContractsAbis, } from "../interfaces/index.js";
let QuestionnairesContract = class QuestionnairesContract extends ERC7529Contract {
    constructor(providerOrSigner, contractAddress) {
        super(providerOrSigner, contractAddress, ContractsAbis.QuestionnairesAbi.abi);
        this.providerOrSigner = providerOrSigner;
        this.contractAddress = contractAddress;
        this.filters = {};
    }
    getContractAddress() {
        return this.contractAddress;
    }
    getQuestionnaires() {
        return ResultAsync.fromPromise(this.contract.getQuestionnaires(), (e) => {
            return this.generateError(e, "Unable to call getQuestionnaires()");
        });
    }
    addQuestionnaire(questionnaireCid, overrides) {
        return this.writeToContract("addQuestionnaire", [questionnaireCid], overrides);
    }
    removeQuestionnaire(index, overrides) {
        return this.writeToContract("removeQuestionnaire", [index], overrides);
    }
    addDomain(domain, overrides) {
        return this.writeToContract("addDomain", [domain], overrides);
    }
    removeDomain(domain, overrides) {
        return this.writeToContract("removeDomain", [domain], overrides);
    }
    checkDomain(domain) {
        return ResultAsync.fromPromise(
        // returns array of domains
        this.contract.checkDomain(domain), (e) => {
            return this.generateError(e, "Unable to call checkDomain()");
        });
    }
    generateContractSpecificError(msg, e, transaction) {
        return new QuestionnairesContractError(msg, e, transaction);
    }
};
QuestionnairesContract = __decorate([
    injectable(),
    __metadata("design:paramtypes", [Object, String])
], QuestionnairesContract);
export { QuestionnairesContract };
//# sourceMappingURL=QuestionnairesContract.js.map