import { BlockchainCommonErrors, FarcasterBundlerContractError } from "@snickerdoodlelabs/objects";
import { ethers } from "ethers";
import { ResultAsync } from "neverthrow";
import { BaseContract } from "../../implementations/BaseContract.js";
import { IEthersContractError } from "../../implementations/BlockchainErrorMapper.js";
import { ContractOverrides, IFarcasterBundlerContract, WrappedTransactionResponse } from "../../interfaces/index.js";
import { RegistrationParams } from "../../interfaces/objects/farcaster/RegistrationParams.js";
import { FarcasterBundlerSignerParams } from "../../interfaces/objects/index.js";
export declare class FarcasterBundlerContract extends BaseContract<FarcasterBundlerContractError> implements IFarcasterBundlerContract {
    protected providerOrSigner: ethers.Provider | ethers.Signer;
    constructor(providerOrSigner: ethers.Provider | ethers.Signer);
    price(extraStorage: bigint): ResultAsync<bigint, FarcasterBundlerContractError | BlockchainCommonErrors>;
    register(registrationParams: RegistrationParams, signerParams: FarcasterBundlerSignerParams[], extraStorage: bigint, overrides?: ContractOverrides): ResultAsync<WrappedTransactionResponse, FarcasterBundlerContractError | BlockchainCommonErrors>;
    protected generateContractSpecificError(msg: string, e: IEthersContractError, transaction: ethers.Transaction | null): FarcasterBundlerContractError;
}
//# sourceMappingURL=FarcasterBundlerContract.d.ts.map